---
title: Collision detection
slug: Games/Tutorials/2D_breakout_game_Phaser/Collision_detection
tags:
  - 2D
  - Beginner
  - Canvas
  - Games
  - JavaScript
  - Phaser
  - Tutorial
  - collision detection
---
<div>{{GamesSidebar}}</div>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser/Build_the_brick_field", "Games/Workflows/2D_Breakout_game_Phaser/The_score")}}</p>

<div class="summary">
<p>This is the <strong>10th step</strong> out of 16 of the <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser">Gamedev Phaser tutorial</a>. You can find the source code as it should look after completing this lesson at <a href="https://github.com/end3r/Gamedev-Phaser-Content-Kit/blob/gh-pages/demos/lesson10.html">Gamedev-Phaser-Content-Kit/demos/lesson10.html</a>.</p>
</div>

<p><span class="seoSummary">Now onto the next challenge — the collision detection between the ball and the bricks. Luckily enough we can use the physics engine to check collisions not only between single objects (like the ball and the paddle), but also between an object and the group.</span></p>

<h2 id="BrickBall_collision_detection">Brick/Ball collision detection</h2>

<p>The physics engine makes everything a lot easier — we just need to add two simple pieces of code. First, add a new line inside your <code>update()</code> function that checks for collision detection between ball and bricks, as shown below:</p>

<pre class="brush: js notranslate">function update() {
    game.physics.arcade.collide(ball, paddle);
    game.physics.arcade.collide(ball, bricks, ballHitBrick);
    paddle.x = game.input.x || game.world.width*0.5;
}
</pre>

<p>The ball's position is calculated against the positions of all the bricks in the group. The third, optional parameter is the function executed when a collision occurs — <code>ballHitBrick()</code>. Create this new function as the bottom of your code, just before the closing <code>&lt;/script&gt;</code> tag, as follows:</p>

<pre class="brush: js notranslate">function ballHitBrick(ball, brick) {
    brick.kill();
}
</pre>

<p>And that's it! Reload your code and you should see the new collision detection working just as required.</p>

<p>Thanks to Phaser there are two parameters passed to the function — the first one is the ball, which we explicitly defined in the collide method, and the second one is the single brick from the bricks group that the ball is colliding with. Inside the function we remove the brick in question from the screen by running the <code>kill()</code> method on it.</p>

<p>You would expect to have to write a lot more calculations of your own to implement collision detection when using <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_pure_JavaScript/Collision_detection">pure JavaScript</a>. That's the beauty of using the framework — you can leave a lot of boring code to Phaser, and focus on the most fun and interesting parts of making a game.</p>

<h2 id="Compare_your_code">Compare your code</h2>

<p>You can check the finished code for this lesson in the live demo below, and play with it to understand better how it works:</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/end3r/wwneakwf/","","400")}}</p>

<h2 id="Next_steps">Next steps</h2>

<p>We can hit the bricks and remove them, which is a nice addition to the gameplay already. It would be even better to count the destroyed bricks increment <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser/The_score">the score</a> as a result.</p>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser/Build_the_brick_field", "Games/Workflows/2D_Breakout_game_Phaser/The_score")}}</p>
